searchNodes=[{"doc":"Example: Graph Coloring","ref":"GraphColoring.html","title":"GraphColoring","type":"module"},{"doc":"","ref":"GraphColoring.html#do_coloring/2","title":"GraphColoring.do_coloring/2","type":"function"},{"doc":"","ref":"GraphColoring.html#optimal_coloring/2","title":"GraphColoring.optimal_coloring/2","type":"function"},{"doc":"","ref":"GraphColoring.html#show_results/1","title":"GraphColoring.show_results/1","type":"function"},{"doc":"Functions for converting data between Minizinc and Elixir.","ref":"MinizincData.html","title":"MinizincData","type":"module"},{"doc":"","ref":"MinizincData.html#elixir_to_dzn/1","title":"MinizincData.elixir_to_dzn/1","type":"function"},{"doc":"","ref":"MinizincData.html#make_dzn/2","title":"MinizincData.make_dzn/2","type":"function"},{"doc":"","ref":"MinizincData.html#output_to_elixir/1","title":"MinizincData.output_to_elixir/1","type":"function"},{"doc":"","ref":"MinizincData.html#t:data_chunk/0","title":"MinizincData.data_chunk/0","type":"type"},{"doc":"","ref":"MinizincData.html#t:mzn_data/0","title":"MinizincData.mzn_data/0","type":"type"},{"doc":"Behaviour, default implementations and helpers for solution handlers.","ref":"MinizincHandler.html","title":"MinizincHandler","type":"behaviour"},{"doc":"","ref":"MinizincHandler.html#c:handle_minizinc_error/1","title":"MinizincHandler.handle_minizinc_error/1","type":"callback"},{"doc":"","ref":"MinizincHandler.html#c:handle_solution/1","title":"MinizincHandler.handle_solution/1","type":"callback"},{"doc":"","ref":"MinizincHandler.html#c:handle_summary/1","title":"MinizincHandler.handle_summary/1","type":"callback"},{"doc":"Functions to construct and access Minizinc model.","ref":"MinizincModel.html","title":"MinizincModel","type":"module"},{"doc":"","ref":"MinizincModel.html#make_model/2","title":"MinizincModel.make_model/2","type":"function"},{"doc":"","ref":"MinizincModel.html#model_method/1","title":"MinizincModel.model_method/1","type":"function"},{"doc":"","ref":"MinizincModel.html#t:model_chunk/0","title":"MinizincModel.model_chunk/0","type":"type"},{"doc":"","ref":"MinizincModel.html#t:mzn_model/0","title":"MinizincModel.mzn_model/0","type":"type"},{"doc":"Functions and data structures for working with data produced by Minizinc during runtime.","ref":"MinizincResults.html","title":"MinizincResults","type":"module"},{"doc":"","ref":"MinizincResults.html#get_last_solution/1","title":"MinizincResults.get_last_solution/1","type":"function"},{"doc":"","ref":"MinizincResults.html#get_solution_index/1","title":"MinizincResults.get_solution_index/1","type":"function"},{"doc":"","ref":"MinizincResults.html#get_solution_objective/1","title":"MinizincResults.get_solution_objective/1","type":"function"},{"doc":"","ref":"MinizincResults.html#get_solution_output/1","title":"MinizincResults.get_solution_output/1","type":"function"},{"doc":"","ref":"MinizincResults.html#get_solution_value/2","title":"MinizincResults.get_solution_value/2","type":"function"},{"doc":"","ref":"MinizincResults.html#get_solutions/1","title":"MinizincResults.get_solutions/1","type":"function"},{"doc":"","ref":"MinizincResults.html#get_status/1","title":"MinizincResults.get_status/1","type":"function"},{"doc":"Minizinc solver API.","ref":"MinizincSolver.html","title":"MinizincSolver","type":"module"},{"doc":"Default Minizinc executable.","ref":"MinizincSolver.html#get_executable/0","title":"MinizincSolver.get_executable/0","type":"function"},{"doc":"Get list of solver ids for solvers available to MinizincSolver.","ref":"MinizincSolver.html#get_solverids/0","title":"MinizincSolver.get_solverids/0","type":"function"},{"doc":"Get list of descriptions for solvers available to MinizincSolver.","ref":"MinizincSolver.html#get_solvers/0","title":"MinizincSolver.get_solvers/0","type":"function"},{"doc":"Lookup a solver by (possibly partial) id; for results, it could be 'cplex' or 'org.minizinc.mip.cplex'","ref":"MinizincSolver.html#lookup/1","title":"MinizincSolver.lookup/1","type":"function"},{"doc":"Shortcut for solve/2.","ref":"MinizincSolver.html#solve/1","title":"MinizincSolver.solve/1","type":"function"},{"doc":"Solve (asynchronously) with model, data and options.Example:# Solve Sudoku puzzle with &quot;mzn/sudoku.mzn&quot; model, &quot;mzn/sudoku.dzn&quot; data, # and custom solution handler Sudoku.solution_handler/2. # MinizincSolver.solve(&quot;mzn/sudoku.mzn&quot;, &quot;mzn/sudoku.dzn&quot;, [solution_handler: &amp;Sudoku.solution_handler/2]) Check out Sudoku module in examples/sudoku.ex for more details on handling solutions.","ref":"MinizincSolver.html#solve/3","title":"MinizincSolver.solve/3","type":"function"},{"doc":"Shortcut for solve_sync/2.","ref":"MinizincSolver.html#solve_sync/1","title":"MinizincSolver.solve_sync/1","type":"function"},{"doc":"Solve (synchronously) with model, data and options.Example:# Solve N-queens puzzle with n = 4. # Use Gecode solver, solve within 1000 ms. # results = MinizincSolver.solve_sync(&quot;mzn/nqueens.mzn&quot;, %{n: 4}, [solver: &quot;gecode&quot;, time_limit: 1000]) Check out NQueens module in examples/nqueens.ex for more details on handling solutions.","ref":"MinizincSolver.html#solve_sync/3","title":"MinizincSolver.solve_sync/3","type":"function"},{"doc":"Stop solver process.","ref":"MinizincSolver.html#stop_solver_process/1","title":"MinizincSolver.stop_solver_process/1","type":"function"},{"doc":"","ref":"MinizincSolver.html#t:solver_opt/0","title":"MinizincSolver.solver_opt/0","type":"type"},{"doc":"","ref":"MinizincSolver.html#t:solver_opts/0","title":"MinizincSolver.solver_opts/0","type":"type"},{"doc":"Example: N-queens solver.","ref":"NQueens.html","title":"NQueens","type":"module"},{"doc":"","ref":"NQueens.html#solve/2","title":"NQueens.solve/2","type":"function"},{"doc":"","ref":"NQueens.html#solve_sync/2","title":"NQueens.solve_sync/2","type":"function"},{"doc":"Example: Sudoku solver. Sudoku puzzle is a string with elements of the puzzle in row-major order, where a blank entry is represented by &quot;.&quot;","ref":"Sudoku.html","title":"Sudoku","type":"module"},{"doc":"Solve asynchronously using Sudoku.AsyncHandler as a solution handler.","ref":"Sudoku.html#solve/2","title":"Sudoku.solve/2","type":"function"},{"doc":"# Solve synchronously. # Example (prints all solutions): Enum.each(Sudoku.solve_sync( &quot;8..6..9.5.............2.31...7318.6.24.....73...........279.1..5...8..36..3......&quot;), fn ({:solution, sol}) -&gt; Logger.info Sudoku.print_grid(sol[&quot;puzzle&quot;]) (_) -&gt; :ok end)","ref":"Sudoku.html#solve_sync/1","title":"Sudoku.solve_sync/1","type":"function"},{"doc":"SolverlErlang/Elixir interface to Minizinc.Inspired by Minizinc Python.Disclaimer: This project is in its very early stages, and has not been used in production, nor extensively tested. Use at your own risk.InstallationFeaturesUsageModel specificationData specificationSupport for Minizinc data typesConfiguring the solverSolution handlers: customizing results and controlling execution ExamplesErlang interfaceRoadmapCredits","ref":"readme.html","title":"Solverl","type":"extras"},{"doc":"You will need to install Minizinc. Please refer to https://www.minizinc.org/software.html for details.Note:The code was only tested on macOS Catalina and Ubuntu 18.04 with Minizinc v2.4.3.Note:minizinc executable is expected to be in its default location, or in a folder in the $PATH env variable. Otherwise, you can use the minizinc_executable option (see Solver Options). The package can be installed by adding solverl to your list of dependencies in mix.exs:def deps do [ {:solverl, &quot;~&gt; 0.1.5&quot;} ] endThe docs can be found at https://hexdocs.pm/solverl.","ref":"readme.html#installation","title":"Solverl - Installation","type":"extras"},{"doc":"Synchronous and asynchronous solvingPluggable solution handlers Support for basic Minizinc types, arrays, sets and enums","ref":"readme.html#features","title":"Solverl - Features","type":"extras"},{"doc":"MinizincSolver module provides functions both for synchronous and asynchronous solving. # Asynchronous solving. # Creates a solver process. {:ok, solver_pid} = MinizincSolver.solve(model, data, opts) # Synchronous solving. # Starts the solver and gets the results (solutions and/or solver stats) once the solver finishes. solver_results = MinizincSolver.solve_sync(model, data, opts) , where model - specification of Minizinc model;data - specification of data passed to model;opts - solver options.Model specificationModel could be either:a string, in which case it represents a path for a file containing Minizinc model. Example: &quot;mzn/sudoku.mzn&quot;or, a tuple {:text, model_text}. Example (model as a multiline string): &quot;&quot;&quot; array [1..5] of var 1..n: x; include &quot;alldifferent.mzn&quot;; constraint alldifferent(x); &quot;&quot;&quot;or a (mixed) list of the above. The code will build a model by concatenating bodies of model files and model texts suffixed with EOL (\\n). Example: [&quot;mzn/test1.mzn&quot;, {:text, &quot;constraint y[1] + y[2] &lt;= 0;&quot;}]Data specificationData could be either:a string, in which case it represents a path for a Minizinc data file. Example: &quot;mzn/sudoku.dzn&quot;a map, in which case map keys/value represent model par names/values. Example: %{n: 5, f: 3.44} or a (mixed) list of the above. The code will build a data file by mapping elements of the list to bodies of data files and/or data maps, serialized as described in Support for Minizinc data types, then concatenating the elements of the list, suffixed with EOL (\\n). Example: [&quot;mzn/test_data1.dzn&quot;, &quot;mzn/test_data2.dzn&quot;, %{x: 2, y: -3, z: true}]Support for Minizinc data typesArrays Minizinc array type corresponds to (nested) List. The code determines dimensions of the array based on its nested structure. Each level of nested list has to contain elements of the same length, or the exception {:irregular_array, array} will be thrown. 6 levels of nesting are currently supported, in line with Minizinc. By default, the indices of the dimensions are 1-based. Example: arr2d = [ [0, 1, 0, 1, 0], [0, 1, 0, 1, 0], [0, 1, 0, 1, 0], [0, 1, 0, 1, 0], [0, 1, 0, 1, 0] ] MinizincData.elixir_to_dzn(arr2d) Output: &quot;array2d(1..5,1..5,[0,1,0,1,0,0,1,0,1,0,0,1,0,1,0,0,1,0,1,0,0,1,0,1,0])&quot; You can explicitly specify bases for each dimension: # Let 1st dimension be 0-based, 2nd dimension be 1-based MinizincData.elixir_to_dzn({[0, 1], arr2d}) Output: &quot;array2d(0..4,1..5,[0,1,0,1,0,0,1,0,1,0,0,1,0,1,0,0,1,0,1,0,0,1,0,1,0])&quot; Sets Minizinc set type corresponds to MapSet. Example: MinizincData.elixir_to_dzn(MapSet.new([2, 1, 6])) Output: &quot;{1,2,6}&quot;Enums Minizinc enum type corresponds to Tuple. Tuple elements have to be either of strings, charlists or atoms. Example 1 (using strings, atoms and charlists for enum entries): MinizincData.elixir_to_dzn({&quot;blue&quot;, :BLACK, &#39;GREEN&#39;}) Output: &quot;{blue, BLACK, GREEN}&quot;Example 2 (solving for enum variable): enum_model = &quot;&quot;&quot; enum COLOR; var COLOR: color; constraint color = max(COLOR); &quot;&quot;&quot; results = MinizincSolver.solve_sync({:text, enum_model}, %{&#39;COLOR&#39;: {&quot;White&quot;, &quot;Black&quot;, &quot;Red&quot;, &quot;BLue&quot;, &quot;Green&quot;}}) results[:summary][:last_solution][:data][&quot;color&quot;] Output: &quot;Green&quot; Solver optionssolver: Solver id supported by your Minizinc configuration. Default: &quot;gecode&quot;.time_limit: Time in msecs given to Minizinc to find a solution. Default: 300000 (5 mins). Use [time_limit: nil] for unlimited time.minizinc_executable: Full path to Minizinc executable (you'd need it if minizinc executable cannot be located by your system).solution_handler: Module or function that controls processing of solutions and/or metadata. Default: MinizincHandler.DefaultAsync. Check out Solution handlers for more details. extra_flags: A string of command line flags supported by the solver. Example: ## Solve &quot;mzn/nqueens.mzn&quot; for n = 4, using Gecode solver, ## time limit of 1 sec, NQueens.SyncHandler as a solution handler. ## Extra flags: -O4 --verbose-compilation MinizincSolver.solve_sync(&quot;mzn/nqueens.mzn&quot;, %{n: 4}, [solver: &quot;gecode&quot;, time_limit: 1000, solution_handler: NQueens.SyncHandler, extra_flags: &quot;-O4 --verbose-compilation&quot;])Solution handlers Solution handler is a pluggable code created by the user in order to customize processing of solutions and metadata produced by MinizincSolver.solve/3 and MinizincSolver.solve_sync/3. Solution handler is specified by solution_handleroption. Solution handler is either a function, ora module that implements MinizincHandler behaviour. Solution handler code acts as a callback for the solver events emitted by MinizincPort, which is a wrapper process for Minizinc executable (see Under the hood for more details). In case the solution handler is a function, its signature has to have 2 arguments, 1st one is an atom denoting the solver event type (i.e., :solution, :summary, :minizinc_error), 2nd being the event-specific data of that event. In case the solution handler is a module that implements MinizincHandler behaviour, its functions handle_solution/1, handle_summary/1, handle_minizinc_error/1 take an event-specific data. Solver eventsSolver event is a tuple {event_type, event_data}.Currently, there are following types of solver events::solution - the new solution detected;:summary - the wrapper sent the summary metadata (usually because the solver had finished);:minizinc_error - the wrapper detected Minizinc runtime error.Event-specific dataFor :solution event: %{ data: data, # Map of values keyed with their variable names timestamp: timestamp, # Timestamp of the moment solution was parsed index: index, # Sequential number of the solution stats: stats # Map of solution statistics values keyed with the field names } For :summary event: %{ status: status, # Solver status (one of :satisfied, :unsatisfiable etc) fzn_stats: fzn_stats, # Map of FlatZinc statistics values keyed with the field names solver_stats: solver_stats, # Map of solver statistics values keyed with the field names solution_count: solution_count, # Total number of solutions found last_solution: solution, # Data for last :solution event (see above) minizinc_output: minizinc_output, # Minizinc errors and warnings time_elapsed: time_elapsed # Time elapsed, verbatim as reported by Minizinc }For :minizinc_error event: %{ error: error # Minizinc output accompanied by runtime error }Customizing results and controlling execution. Solution handlers can modify or ignore data passed by solver events, or interrupt the solver process early, by constructing their returns in desired form. The return of the solution handler callback could be one of::stop Solution handler stops receiving solver events and asks solver to stop execution.{:stop, data} Same as above, but in case of synchronous solving, data will be added to solver results.:skip The event will be ignored, i.e. in case of synchronous solving, the results will not be changed. data :: any() In case of synchronous solving, data will be added to solver results.Solver resultsNote: this is applicable only to a synchronous solving. Solver results is a map with the following keys::solutions - list of data elements, accumulated by handling of :solution events:summary - data, produced by handling of :summary event:minizinc_error - data, produced by handling of :minizinc_error eventPlease refer to Event-specific data for description of data for solver events.Handling exceptionsSolution handler is a pluggable code that is typically created by a user. MinizincSolver catches exceptions from solution handlers to make sure that the solver process is gracefully shut down. Moreover, in case of synchronous solving, MinizincSolver preserves the solver results accumulated before the exception, and returns them to the calling process. The exception value will be added to solver results under :handler_exception key.","ref":"readme.html#usage","title":"Solverl - Usage","type":"extras"},{"doc":"N-QueensSudokuGraph ColoringMore examples in unit testsN-QueensSource codeModel The following code solves N-queens puzzle for N = 4: NQueens.solve(4, [solution_handler: &amp;NQueens.solution_handler/2]) Output: 17:16:53.073 [warn] Command: /Applications/MiniZincIDE.app/Contents/Resources/minizinc --allow-multiple-assignments --output-mode json --output-time --output-objective --output-output-item -s -a --solver org.gecode.gecode --time-limit 300000 /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.vFlJER37.mzn /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.rxTZq96j.dzn {:ok, #PID&lt;0.766.0&gt;} iex(75)&gt; 17:16:53.174 [info] . . ♕ . ♕ . . . . . . ♕ . ♕ . . ----------------------- 17:16:53.174 [info] . ♕ . . . . . ♕ ♕ . . . . . ♕ . ----------------------- 17:16:53.179 [info] Solution status: all_solutions 17:16:53.179 [info] Solver stats: %{failures: 4, initTime: 0.007719, nSolutions: 2, nodes: 11, peakDepth: 2, propagations: 163, propagators: 11, restarts: 0, solutions: 2, solveTime: 0.002778, variables: 12} 17:16:53.179 [debug] ** TERMINATE: :normal SudokuSource codeModel Sudoku.solve(&quot;85...24..72......9..4.........1.7..23.5...9...4...........8..7..17..........36.4.&quot;)The output:17:19:28.109 [info] Sudoku puzzle: 17:19:28.109 [info] +-------+-------+-------+ | 8 5 . | . . 2 | 4 . . | | 7 2 . | . . . | . . 9 | | . . 4 | . . . | . . . | +-------+-------+-------+ | . . . | 1 . 7 | . . 2 | | 3 . 5 | . . . | 9 . . | | . 4 . | . . . | . . . | +-------+-------+-------+ | . . . | . 8 . | . 7 . | | . 1 7 | . . . | . . . | | . . . | . 3 6 | . 4 . | +-------+-------+-------+ 17:19:28.154 [warn] Command: /Applications/MiniZincIDE.app/Contents/Resources/minizinc --allow-multiple-assignments --output-mode json --output-time --output-objective --output-output-item -s -a --solver org.gecode.gecode --time-limit 300000 /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.uSF45sHN.mzn /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.KjyUqmEa.dzn {:ok, #PID&lt;0.776.0&gt;} iex(79)&gt; 17:19:28.219 [info] +-------+-------+-------+ | 8 5 9 | 6 1 2 | 4 3 7 | | 7 2 3 | 8 5 4 | 1 6 9 | | 1 6 4 | 3 7 9 | 5 2 8 | +-------+-------+-------+ | 9 8 6 | 1 4 7 | 3 5 2 | | 3 7 5 | 2 6 8 | 9 1 4 | | 2 4 1 | 5 9 3 | 7 8 6 | +-------+-------+-------+ | 4 3 2 | 9 8 1 | 6 7 5 | | 6 1 7 | 4 2 5 | 8 9 3 | | 5 9 8 | 7 3 6 | 2 4 1 | +-------+-------+-------+ 17:19:28.219 [info] Solutions found: 1 17:19:28.224 [info] Status: all_solutions 17:19:28.224 [info] Solver statistics: %{failures: 11, initTime: 0.001401, nSolutions: 1, nodes: 23, peakDepth: 5, propagations: 685, propagators: 27, restarts: 0, solutions: 1, solveTime: 0.001104, variables: 147} 17:19:28.224 [debug] ** TERMINATE: :normalGraph coloringSource codeModelThe model's objective is to minimize the number of colors for proper Graph Vertex Coloring.edges = [ [0, 1], [1, 2], [1, 3] ] vertices = 4 ## Color graph with time limit of 1 sec: GraphColoring.do_coloring({vertices, edges}, [time_limit: 1*1000]) Output: 22:43:01.318 [info] Found coloring to 2 colors 22:43:01.328 [info] Best coloring found: 2 colors 22:43:01.328 [info] Optimal? Yes 22:43:01.328 [info] Color 1 -&gt; vertices: 0, 2, 3 22:43:01.328 [info] Color 2 -&gt; vertices: 1","ref":"readme.html#model-solving-examples","title":"Solverl - Model solving examples","type":"extras"},{"doc":"minizinc module mirrors all exported functions of MinizincSolver module.Once you manage to make solverl dependency part of your Erlang application build (for instance with rebar_mix), you should be able to use its interface.Example:results = minizinc:solve_sync(&lt;&lt;&quot;mzn/nqueens.mzn&quot;&gt;&gt;, \#{n=&gt; 4}, [{solution_handler, fun 'Elixir.NQueens':solution_handler/2}]).Note: Please use binary strings as opposed to char strings whenever you need to pass a string to API. The API functions will always use binary strings whenever the function return needs to use strings.","ref":"readme.html#erlang-interface","title":"Solverl - Erlang interface","type":"extras"},{"doc":"Both MinizincSolver.solve/3 and MinizincSolver.solve_sync/3 use MinizincPort.start_link/3 to start GenServer process, which in turn spawns the external MiniZinc process, and then parses its text output into solver events and makes appropriate callback function calls as described here.","ref":"readme.html#under-the-hood","title":"Solverl - Under the hood","type":"extras"},{"doc":"Support LNS; Support Branch-and-Bound; Provide API for peeking into a state of Minizinc process, such as time since last solution, whether it&#39;s compiling or solving at the moment etc. Match minizinc-python functionality.","ref":"readme.html#roadmap","title":"Solverl - Roadmap","type":"extras"},{"doc":"The project extensively uses ideas and code examples from Minizinc Python.","ref":"readme.html#credits","title":"Solverl - Credits","type":"extras"}]